/* SPDX-License-Identifier: GPL-2.0 or Linux-OpenIB */
/* Copyright (c) 2024 ZTE Corporation.  All rights reserved. */
#ifndef ZXDH_RDMA_PRIVATE_VERBS_CMD_H
#define ZXDH_RDMA_PRIVATE_VERBS_CMD_H

#include "main.h"
#include "zxdh_dv.h"

struct zxdh_uvcontext_ops {
	int (*modify_qp_udp_sport)(struct ibv_context *ibctx,
				   uint16_t udp_sport, uint32_t qpn);
	int (*set_log_trace_switch)(struct ibv_context *ibctx,
				    uint8_t switch_status);
	int (*get_log_trace_switch)(struct ibv_context *ibctx,
				    uint8_t *switch_status);
	int (*query_qpc)(struct ibv_qp *qp, struct zxdh_rdma_qpc *qpc);
	int (*modify_qpc)(struct ibv_qp *qp, struct zxdh_rdma_qpc *qpc,
			  uint64_t qpc_mask);
	int (*reset_qp)(struct ibv_qp *qp, uint64_t opcode);
};

void add_private_ops(struct zxdh_uvcontext *iwvctx);

#endif
